(require '[clojure.core.protocols :refer [CollReduce coll-reduce]])
        
; producing a generic reducer: transforms the reducing function
; according to the transformation 'transformf'
(defn reducer [reducible transformf]
  (reify
    CollReduce
    (coll-reduce [_ f1 init]
      (coll-reduce reducible (transformf f1) init))))

; How map changes the reducing function
(defn mapping [f]
  (fn [reduce_f]
      (fn [acc next]
          (reduce_f acc (f next)))))

; reimplementation of map
(defn my-map [f reducible]
  (reducer reducible (mapping f)))
