(def search-engines
    {:bing "https://www.bing.com/"
     :google "https://www.google.com/"})

(defn search [search-term & engines]
  (let [results (promise)]
    (doseq [engine engines]
      (future (deliver results                   
                       (slurp (str (engine search-engines) 
                                   "search?q%3D" 
                                   search-term)
                              )
                       )))
    
    @results))

;; only provides the winner (not result)
(defn search-comp [search-term & engines]
  (let [
        result (promise)
        winner (promise)
        ]
    (doseq [engine engines]
      (future (do
                (deliver result             
                        (slurp (str (engine search-engines) 
                                    "search?q%3D" 
                                    search-term)
                               )
                        )
               
                (deliver winner engine)
               )
              )     
      )
    @result
    @winner
    )
  )

