(def account1 (ref 100000))
(def account2 (ref 200000))

(def tries     (atom 0))
(def commits (agent 0))

(defn transfer [from to amount]
  (dosync
   ; counts the number of tries (side-effect in transaction)   
   (swap! tries inc)

   ; operation on agent: executed only when transaction succeeds,
   ; count the succefssful transfers
   (send commits inc)

   ; transactional part
   (alter from - amount)
   (alter to + amount)))

(defn stress-proc [from to iterations amount]
  (future (dotimes [_ iterations] (transfer from to amount))))


;; main
(println "Start: Account1 =" @account1 " Account2 =" @account2)
(def p1 (stress-proc account1 account2 100 1000))
(def p2 (stress-proc account2 account1 200 1000))
@p1
@p2
(println "Attempts: " @tries)
(println "Transfers: " @commits)
(println "End:  Account1 =" @account1 " Account2 =" @account2)


;(shutdown-agents)
